anodiv<-function(...) {
   UseMethod("anodiv")
}

anodiv.default<-function(Y,X=NULL,mod=NULL) {
   if(is.null(X)) {
        mod<-1
        Y<-as.matrix(Y)
        N<-sum(Y)
        SV<-(cw<-colSums(Y)/N)*(1-cw)
        var<-Vinter(Y)
        spvar<-data.frame(as.numeric(SV),as.numeric(var),as.numeric(SV-var),row.names=names(SV))
        names(spvar)<-c("Total","Among-rows","Residuals")
        df<-c(dfa<-(nrow(Y)-1),(N-dfa-1))
        names(df)<-c("Among-rows","Residuals")
        util<-odf(Y)
        Y<-util[,1]
        X<-data.frame(util[,2])
        cl<-paste(match.call()$Y)
        names(X)<-ifelse(("$"%in%cl),c(paste(cl[[3]],".row",sep="")),c(paste(cl,".row",sep="")))
    }
    else {
        N<-length(Y)
        vart<-as.vector((cw<-table(Y)/N)*(1-cw))
        lev<-c()
		vari<-matrix(0,length(vart),ncol(X))
        for(i in 1:ncol(X)) {
			vari[,i]<-Vinter(table(X[,i],Y))
            lev[i]<-nlevels(X[,i])
        }
		if(attr(mod,"hierarchical")) {
			var<-vari[,1]
			df<-lev[1]-1
			varsum<-0
			for(i in 2:(ncol(X))) {
				var<-cbind(var,(vari[,i]-vari[,(i-1)]))
				df<-c(df,lev[i]-lev[i-1])
			}
		}
		else {
			var<-vari
			df<-lev-1
		}
		var<-data.frame(vart,var)
        res<-var[,1]-apply(t(var[,-1]),2,sum)
        res[res<=0]<-.Machine$double.eps #zap small
        spvar<-data.frame(var,res,row.names=levels(Y))
        names(spvar)<-c("Total",names(X),"Residuals")
        df<-c(df,N-sum(df)-1)
        names(df)<-c(names(X),"Residuals")
    }
    res<-alist()
    res$Y<-Y
    res$X<-X
    res$spw<-cw
    res$spvar<-spvar
    res$df<-df
    res$mod<-mod
    res$call<-match.call()
    class(res)<-c("div","anodiv")
    return(res)
}

anodiv.formula<-function(formula, data) {
	if (missing(data)) data<-parent.frame()
	Terms<-terms(formula,data=data)
	formula<-formula(Terms,width.cutoff=500)
    Iterm<-formula[[2]]
	Y<-eval(Iterm,data,parent.frame())
    Xterm<-formula[[3]]
	X.formula<-as.formula(paste("~",deparse(Xterm)))
	X<-model.frame(X.formula,data,na.action=na.fail)
  	Xterms<-attr(X,"terms")
	mod<-attr(Xterms,"order")
	if((length(mod)>1)&&(identical(as.vector(mod),seq(1,length(mod)))))
		attr(mod,"hierarchical")<-TRUE
	else
		attr(mod,"hierarchical")<-FALSE
	#if(length(mod)>1)
	#	h<-attr(mod,"hierarchical")<-is.hierarchical(X,"downward")
	clasXvar<-attr(Xterms,"dataClasses")
    if(!all(clasXvar=="factor")) stop("all independent variables should be factors")
    tlabs<-attr(Xterms,"term.labels")
    xi<-alist()	
	for(i in 1:length(tlabs)) {
		xi[[i]]<-factor(eval(parse(text=tlabs[i]),X),exclude=NULL)
	}
	if(!is.factor(Y)) {
        util<-odf(Y,xi)
        Y<-util[,1]
        xi<-util[,((ncol(util)-length(xi)+1):ncol(util))]
    }
    X<-data.frame(xi)
	names(X)<-tlabs
	res<-anodiv.default(factor(Y,exclude=NULL),X,mod)
	res$call<-match.call()
    return(res)
}
