dudi.div<-function(Ytab,scanopt=TRUE,opt=1,scannf=TRUE,nf=2,call=match.call(),full=FALSE)
{
    N<-sum(Ytab)
    rw<-rowSums(Ytab)/N
    cw<-colSums(Ytab)/N
    Ytab<-t(apply(Ytab,1,function(x) if(sum(x)==0) cw else x/sum(x)))
    Ytab<-sweep(Ytab,2,cw)
    if(scanopt) {
        cat("Select a diversity index (1=richness, 2=Shannon, 3=Simpson) :")
        opt<-as.integer(readLines(n=1))
    }
    if(opt==1) {
        spw<-1/cw
        DT<-sum(1-cw)
    }
    else if(opt==2) {
        spw<-log(1/cw)/(1-cw)
        DT<-sum(cw*log(1/cw))
    }
    else if(opt==3) {
        spw<-rep(1,ncol(Ytab))
        DT<-sum(cw*(1-cw))
    }
    else stop("non convenient diversity index") 
    dudi<-as.dudi(data.frame(Ytab),spw,rw,scannf=scannf,nf=nf,call=call,type="div",full=full)
    dudi$divopt<-opt
    dudi$Dtot<-DT
    dudi
}
