kmsov.rtest<-function(dudi, knb, ax , fac = NULL, nrepet = 300) {
	require(spdep)
	if (!inherits(dudi, "dudi"))
		stop("object of class 'dudi' expected")
	if (!inherits(knb, "knb"))
		stop("object of class 'knb' expected")
	X <- as.matrix(dudi$tab)
	col.w <- dudi$cw
	w <- sqrt(col.w)
	row.w <- dudi$lw
	n <- nrow(X)
	p <- ncol(X)
	i <- as.matrix(rep(1,n))
	nax <- length(ax)
	gammafh.lower <- lower.tri(matrix(0, nrow = nax, ncol = nax), diag = TRUE)
	Uf <- dudi$c1 * sqrt(dudi$cw)
	Uf <- as.matrix(Uf[, ax])
	# on calcule pour une relation de voisinage d'une distance h donnee
	fun <- function(nb) {
		gh <- neig2mat(nb2neig(nb))
		# les variogrammes des axes principaux
		fun1 <- function(permuter = TRUE) {
			if (permuter) {
				permutation <- sample(n)
				if(!is.null(fac))
				permutation <- unsplit(lapply(split(1:n, fac), function(x) x[sample(length(x))]), fac)
				X <- X[permutation, ]
				row.w <- row.w[permutation]
				mh <- diag(row.w)%*%gh%*%diag(row.w)
				kh <- sum(mh)
				nh <- diag(as.vector(mh%*%i))
				L <- nh-mh
				covh <- t(X)%*%L%*%X
				covh <- sweep(covh, 2, w, "*")
				covh <- covh * w
				gammafh <- t(Uf)%*%covh%*%Uf
				gammafh <- gammafh/kh
				res <- gammafh[gammafh.lower]
			}
			else {
				mh <- diag(row.w)%*%gh%*%diag(row.w)
				kh <- sum(mh)
				nh <- diag(as.vector(mh%*%i))
				L <- nh-mh
				covh <- t(X)%*%L%*%X
				covh <- sweep(covh, 2, w, "*")
				covh <- covh * w
				gammafh <- t(Uf)%*%covh%*%Uf
				gammafh <- gammafh/kh
				res <- gammafh[gammafh.lower]
			}
			return(res)
		}
		obs <- fun1(permuter = FALSE)
		if (nrepet == 0)
			return(t(as.data.frame(obs)))
		else {
			perm <- unlist(lapply(1:nrepet, fun1))
			perm <- matrix(perm, nrow = nrepet, byrow = TRUE)
			res <- rbind.data.frame(obs, perm)
		}
	return(res)
	}
	res<-alist()
	res$vario <- lapply(knb, fun)
	res$nax<-nax
	res$nrepet<-nrepet
###	
	class(res)<-"kmsov"
	return(res)
}
###
	# on donne la sortie graphique
	#fun2 <- function(res) {
plot.kmsov<-function(res,...) {
###		
		nax<-res$nax
		nrepet<-res$nrepet
		res<-res$vario
		x <- as.numeric(substr(names(res),3,10))
		def.par <- par(no.readonly = TRUE)
		on.exit(par(def.par))
		plot.default(0,0,type="n",asp=1,xlab="",ylab="",xaxt="n",yaxt="n",xlim=c(0,1),ylim=c(0,1),xaxs="i",yaxs="i",frame.plot=FALSE)
		par(mfrow = c(nax,nax))
		par(mar = c(4,3,0.5,0.5))
		k <- 1
		for(i in 1:nax) {
			for(j in i:nax) {
				par(mfg = c(i,j))
				y <- unlist(lapply(res, function(x) x[1, k]))
				if (j == i)
					ylim <- c(0, max(y) * 1.5)
				else
					ylim <- c(min(y) * 3, abs(max(y)) * 3)
				plot(x, y, type = "b", pch = 20, lwd = 2, xlab = "Distance (h)", ylab = "", main= if(i!=j) paste("\n\n axes ",i,"-",j) else paste("\n\n axis ",i), ylim = ylim)
				if (nrepet != 0) {
					y0975 <- unlist(lapply(res, function(x) quantile(x[2:(nrepet + 1), k], 0.975)))
					ymean <- unlist(lapply(res, function(x) mean(x[2:(nrepet + 1), k])))
					y0025 <- unlist(lapply(res, function(x) quantile(x[2:(nrepet + 1), k], 0.025)))
					lines(x, y0975, lty = 2)
					lines(x, ymean, lty = 3)
					lines(x, y0025, lty = 2)
				}
				k <- k + 1
			}
		}
	}
	#fun2(res)
	#return(res)
#} 

"bornes2knb" <- function(xy, d) {
	require(spdep)
	xy <- as.matrix(xy)
	nnb <- length(d) - 1
	res <- NULL
	u <- NULL
	for(i in 1:nnb) {
		res[[i]] <- dnearneigh(xy, d[i], d[i + 1])
		u[i] <- (d[i] + d[i + 1]) / 2
	}
	v <- rep("d", nnb)
	u <- paste(v, u, sep = "_")
	names(res) <- u
	class(res) <- "knb"
	return(res)
}

