nsca.simpson<-function(...) {
   UseMethod("nsca.simpson")
}
        
nsca.simpson.default<-function(Y,X=NULL,Z=NULL,test=TRUE,nrepet=999) {
    if(is.factor(Y)) Y<-as.otab(Y)
    if((is.null(X))&&(is.null(Z))) { ## simple nsca of Y
        res<-dudi.div(Y,scanopt=FALSE,opt=3)
        if(test) {
		   if(!all(as.matrix(Y)%in%c(0,1)))
                res$pvalue<-randtest.div(res,nrepet,Y)$pvalue
            else
		       print("Caution: no applicable 'randtest' method")
         }
    }
    else {
        Ydudi<-dudi.div(Y,scanopt=FALSE,opt=3,scannf=FALSE)
    	if((!is.null(X))&&(is.null(Z))) { ## nscaiv of Y with respect to X
            if(is.factor(X)) res<-between(Ydudi,X)
            else res<-pcaiv(Ydudi,X)
            if(test) res$pvalue<-randtest.div(res,nrepet,Ydudi,X,Ydudi$Dtot)$pvalue
        }
        else if((is.null(X))&&(!is.null(Z))) { ## orthonscaiv of Y knowing Z
            if(is.factor(Z)) res<-within(Ydudi,Z)
            else res<-pcaivortho(Ydudi,Z)
            if(test) print("Caution: no applicable 'randtest' method")
            test<-FALSE
        }
        else if((!is.null(X))&&(!is.null(Z))) { ## partialnscaiv of Y knowing Z with respect to X
            if(is.factor(Z)) Zdudi<-within(Ydudi,Z,scannf=FALSE)
            else Zdudi<-pcaivortho(Ydudi,Z,scannf=FALSE)
            if(is.factor(X)) res<-between(Zdudi,X)
            else res<-pcaiv(Zdudi,X)
            if(test) res$pvalue<-randtest.div(res,nrepet,Zdudi,X,Ydudi$Dtot)$pvalue
        }
        class(res)<-c("div",class(res))
        res$divopt<-Ydudi$divopt
        res$Dtot<-Ydudi$Dtot
	}
	if(test) res$nrepet<-nrepet
    res$call<-match.call()
    return(res)
}

nsca.simpson.formula<-function(formula,data,test=TRUE,nrepet=999)
{
    if (missing(data)) data<-parent.frame()
    fmla<-Cformula(formula,data)
    Y<-fmla$Y
    X<-fmla$X
    Z<-fmla$Z
    res<-nsca.simpson.default(Y,X,Z,test,nrepet)
####res$calldef<-res$call
    res$call<-match.call()
    return(res)
}
