otab<-function(fac) {
    if(!is.factor(fac)) stop("fac is not a 'factor'")
    tab<-table(as.factor(c(1:length(fac))),fac)
    class(tab)<-c("otab",class(tab))
    return(tab)
}

as.otab<-function(x) {
    if(is.otab(x)) return(x)
    else if(is.factor(x)) return(otab(x))
    #else if((length(dim(x))==2)&&(all(as.matrix(x)%in%c(0,1)))) {
    else if((length(dim(x))==2)&&(all(as.matrix(x)%in%c(0,1)))&&(all(apply(x,1,sum)==1))) {
    	tab<-as.table(unclass(as.matrix(x)))
        if(is.null(dimnames(x)[[1]])) dimnames(tab)[[1]]<-as.character(c(1:nrow(tab)))
        if(is.null(dimnames(x)[[2]])) dimnames(tab)[[2]]<-as.character(paste("Sp",c(1:ncol(tab)),sep=""))
    }
    else stop("cannot coerce into 'otab'")
    class(tab)<-c("otab",class(tab))
    return(tab)
}

is.otab<-function(x) inherits(x,"otab")

summary.otab<-function(x) {
    cat("Species occurrence table summary")
    cat("\nclass: ")
    cat(class(x))
    cat("\nnumber of occurences: ")
    cat(sum(x))
    cat("\n\n")
    f<-function(a) return(signif(a,digit=3))
    cw<-colSums(x)/sum(x)
    res<-alist()
    res$SV<-cw*(1-cw)
    res$DT<-c(Richness=sum(1-cw),Shannon=sum(log(1/cw)*cw),Simpson=sum(cw*(1-cw)))
    sumry<-array("",c(3,2),list(1:3,c("","DT")))
    sumry[1,]<-c("Richness",f(res$DT[1]))
    sumry[2,]<-c("Shannon",f(res$DT[2]))
    sumry[3,]<-c("Simpson",f(res$DT[3]))
    class(sumry)<-"table"
    print(sumry)
    cat("\n")
    invisible(res)
}

as.data.frame.otab<-function(x,...) as.data.frame.matrix(x,...)
