print.div<-function(div.obj,...) {
    UseMethod("print.div")
}

print.div.dudi<-function(x,...) {
	print.dudi(x,...)
}

print.div.anodiv<-function(x,...) {
    cat("Analysis of species variance\n")
    cat("class: ")
    cat(class(x))
    cat("\n$call: ")
    print(x$call)
    cat("$mod: ",x$mod,"\n")
    #cat(x$mod,if(attr(x$mod,"nested")) "nested","\n")
    cat("\n")
    sumry<-array("",c(3,4),list(1:3,c("vector","length","mode","content")))
    sumry[1,]<-c("$Y",length(x$Y),mode(x$Y),"dependent (species) factor")
    sumry[2,]<-c("$spw",length(x$spw),mode(x$spw),"species weight")
    sumry[3,]<-c("$df",length(x$df),mode(x$df),"terms model degrees of freedom")
    class(sumry)<-"table"
    print(sumry)
    cat("\n")
    sumry<-array("",c(2,4),list(1:2,c("data.frame","nrow","ncol","content")))
    sumry[1,]<-c("$X",nrow(x$X),ncol(x$X),"explanatory factors")
    sumry[2,]<-c("$spvar",nrow(x$spvar),ncol(x$spvar),"species variances")
    class(sumry)<-"table"
    print(sumry)
    cat("\n")
}

print.div.dissim<-function(x,...) {
    cat("Contrast/Dissimilarity analysis\n")
    cat("class: ",class(x),"\n")
    cat("call: ")
    print(x$call)
    if(is.null(x$mod)) {
    	cat("\n")
        sumry<-array("",c(3,4),list(1:3,c("data.frame","nrow","ncol","content")))
    	sumry[1,]<-c("$delta",nrow(x$delta),ncol(x$delta),"by-species contrast matrices (lower triangles)")
    	sumry[2,]<-c("$dissim",nrow(x$dissim),ncol(x$dissim),"dissimilarity matrices (lower triangles)")
    	sumry[3,]<-c("$index",nrow(x$index),ncol(x$index),"contrast indices")
    	class(sumry)<-"table"
    	print(sumry)
    	cat("\n")
    	sumry<-array("",c(1,4),list(1:1,c("vector","length","mode","content")))
    	sumry[1,]<-c("$weight",length(x$weight),mode(x$weight),"contrast weights")
    	class(sumry)<-"table"
        print(sumry)
    }
    else {
        if(identical(x$mod,1)) mod<-c(x$mod,"(One-way)\n")
        if(identical(x$mod,c(1,2))) mod<-c(x$mod,"(Two-way nested)\n")
        cat("$mod: ",mod)
        cat("distance range: (",x$range[1],",",x$range[2],"]\n",sep="")   		
        cat("\nSummary table: ")
    	if(!is.null(x$nrepet)) cat("tests based on",x$nrepet,"distance permutations\n") else cat("\n")
    	print(signif(x$dis,digits=3))
    	cat("\n")
    	sumry<-array("",c(1,4),list(1:1,c("data.frame","nrow","ncol","content")))
    	sumry[1,]<-c("$spdis",nrow(x$spdis),ncol(x$spdis),"by-species range-related contrasts")
    	class(sumry)<-"table"
    	print(sumry)
    }
}	

print.div.spadis<-function(x,...) {
    cat("Contrast/Dissimilarity analysis\n")
    cat("class: ",class(x),"\n")
    cat("call: ")
    print(x$call)
    if(identical(x$mod,1)) mod<-c(x$mod,"(One-way)\n")
    if(identical(x$mod,c(1,2))) mod<-c(x$mod,"(Two-way nested)\n")
    cat("$mod: ",mod)
    cat("distance range: (",x$range[1],",",x$range[2],"]\n",sep="")   		
    cat("\nSummary table: ")
    if(!is.null(x$nrepet)) cat("tests based on",x$nrepet,"distance permutations\n") else cat("\n")
    print(signif(x$dis,digits=3))
    cat("\n")
    sumry<-array("",c(1,4),list(1:1,c("data.frame","nrow","ncol","content")))
    sumry[1,]<-c("$spdis",nrow(x$spdis),ncol(x$spdis),"by-species range-related contrasts")
    class(sumry)<-"table"
    print(sumry)
}	

print.div.variodis<-function(x,...) {
    cat("Distance-related dissimilarity analysis\n")
    cat("class: ",class(x),"\n")
    cat("call: ")
    print(x$call)
    cat("\n")
    if(!is.null(x$nrepet)) cat(x$alpha*100,"% bilateral CI computed from",x$nrepet,"distance permutations\n\n")
    sumry<-array("",c(3,4),list(1:3,c("data.frame","nrow","ncol","content")))
    sumry[1,]<-c("$richness",nrow(x$richness),ncol(x$richness),"variogram of dissimilarity")
    sumry[2,]<-c("$Shannon",nrow(x$Shannon),ncol(x$Shannon),"variogram of dissimilarity")
    sumry[3,]<-c("$Simpson",nrow(x$Simpson),ncol(x$Simpson),"variogram of dissimilarity")
    class(sumry)<-"table"
    print(sumry)
    cat("\n")
    sumry<-array("",c(2,4),list(1:2,c("vector","length","mode","content")))
    sumry[1,]<-c("$h",length(x$h),mode(x$h),"distance")
    sumry[2,]<-c("$w",length(x$w),mode(x$w),"bins weigths")
    class(sumry)<-"table"
    print(sumry)
}
