spadis<-function(formula,data,range=c("min","max"),test=TRUE,nrepet=999) {  
    if (missing(data)) data<-parent.frame()
    Terms<-terms(formula,data=data)
    mod<-as.numeric(attr(Terms,"order"))
    vars<-row.names(attr(Terms,"factors"))
    formula<-formula(Terms,width.cutoff=500)
    Dterm<-formula[[2]]
	df<-eval(Dterm,data,parent.frame())
    nsp<-ncol(df)
    cw<-colSums(df)/sum(df)
    if(identical(mod,1)) XYterm<-formula[[3]]
    else if(identical(mod,c(1,2))) {
        Iterm<-formula[[3]][[3]]
        XYterm<-formula[[3]][[2]]
    }
	xy<-eval(XYterm,data,parent.frame())
    if(ncol(xy)!=2) stop("illegal number of columns in coordinates data.frame")
    if(nrow(df)!=nrow(xy)) stop("non convenient dimensions")
#divindex<-function(x,col.w) return(c(sum(x*1/col.w,na.rm=TRUE),sum(x*log(1/col.w)/(1-col.w),na.rm=TRUE),sum(x)))
#    distfast<-function(x) {
#        N<-nrow(x<-as.matrix(x))
#    	d<-.C("R_distance",
#	    x=as.double(x),
#	    nr=N,
#	    nc=ncol(x),
#	    d=double(N*(N - 1)/2),
#		diag=as.integer(FALSE),
#	    method=as.integer(1),
#	    p = as.double(2),
#	    DUP=FALSE,NAOK=TRUE,PACKAGE='diversity.R')$d
#   }
    weight<-function(x,rw) {
        nlig<-nrow(x)
    	d<-matrix(0,nlig,nlig)
    	d.names<-row.names(x)
        index<-cbind(col(d)[col(d)<row(d)],row(d)[col(d)<row(d)])
        return(as.numeric(rw[index[,1]]*rw[index[,2]]))
    }
    res<-alist()
    res$mod<-mod
    if(identical(mod,1)) { #one-way
    	nr<-nrow(df)
        nsp<-ncol(df)
        N<-sum(df)
        rw<-rowSums(df)/N
        cw<-colSums(df)/N
        df<-t(apply(df,1,function(x) if(sum(x)==0) cw else x/sum(x)))
        df<-sweep(df,2,cw)
        w<-weight(df,rw)
        dw<-apply(df,2,dist)^2*w
        d<-dist(xy)
		atd<-attributes(d)
        if(range[1]=="min") dmin<-floor(min(d)) else dmin<-as.numeric(range[1])
        if(range[2]=="max") dmax<-ceiling(max(d)) else dmax<-as.numeric(range[2])
        res$range<-c(dmin,dmax)
        d<-as.numeric(cut(d,c(dmin,dmax),labels=FALSE))
        d[is.na(d)]<-0
		attributes(d) <- atd
        SVa<-colSums(dw)
        Da<-divindex(SVa,cw)
        SVr<-colSums(dw*d)
        Dr<-divindex(SVr,cw)
        if(test) {
            res$nrepet<-nrepet
            isim<-c(SVr,Dr)
            for(i in 1:nrepet) {
                alea<-.Internal(sample(nr,nr,FALSE,NULL))
				dsim<-as.dist(as.matrix(d)[alea,alea])
				attributes(dsim) <- atd
				isim<-.Internal(rbind(1,isim,c(x<-colSums(dw*dsim),divindex(x,cw))))
            }
            pvalsp<-apply(isim[,1:nsp],2,function(x) as.randtest(x[-1],x[1])$pvalue)
            pval<-apply(isim[,(nsp+1):(nsp+3)],2,function(x) as.randtest(x[-1],x[1])$pvalue)
        }
        res$dis<-data.frame(cbind(Da,Dr,if(test) pval),row.names=c("Richness","Shannon","Simpson"))
        names(res$dis)<-c("Da","Dr",if(test) "Pr(>Dr)")
        res$spdis<-data.frame(cbind(SVa,SVr,if(test) pvalsp))
            names(res$spdis)<-c("SVa","SVr",if(test) "Pr(>SVr)")
    }
    else if(identical(mod,c(1,2))) { #two-way nested
       Xfac<-eval(Iterm,data,parent.frame())
        if(!is.factor(Xfac)) stop("the second dependent variable is not a factor")
        if(length(Xfac)!=nrow(df)) stop("non convenient dimensions")
        ldf<-split(as.data.frame(cbind(df,xy)),Xfac)
        fw<-unlist(lapply(ldf,function(x) sum(x[,1:nsp])))/sum(df)
        discond<-function(df,nsp,range,nrep=0) {
            xy<-df[,(nsp+1):(nsp+2)]
            df<-df[,1:nsp]
            nr<-nrow(df)
            N<-sum(df)
            rw<-rowSums(df)/N
            cw<-colSums(df)/N
            df<-t(apply(df,1,function(x) if(sum(x)==0) cw else x/sum(x)))
            df<-sweep(df,2,cw)
            w<-weight(df,rw)
            dw<-apply(df,2,dist)^2*w
            d<-dist(xy)
			atd<-attributes(d)
            if(range[1]=="min") dmin<-floor(min(d)) else dmin<-as.numeric(range[1])
            if(range[2]=="max") dmax<-ceiling(max(d)) else dmax<-as.numeric(range[2])
            d<-as.numeric(cut(d,c(dmin,dmax),labels=FALSE))
            d[is.na(d)]<-0
            attributes(d) <- atd
            t<-rep(0,(nrepet+2)*nsp)
            t[1:nsp]<-colSums(dw)
            t[(nsp+1):(2*nsp)]<-colSums(dw*d)
            if(nrep!=0)
            for(i in 1:nrepet) {	
                alea<-.Internal(sample(nr,nr,FALSE,NULL))
				dsim<-as.dist(as.matrix(d)[alea,alea])
				attributes(dsim) <- atd
                t[(((i+1)*nsp)+1):(((i+1)*nsp)+nsp)]<-colSums(dw*dsim)
            }
            return(t)
        }
        if(test) {
            res$nrepet<-nrepet
            lres<-apply(do.call("rbind",lapply(ldf,discond,nsp,range,nrep=nrepet)),2,function(x) sum(x*fw))
            matres<-matrix(lres,ncol=nsp,byrow=TRUE)
            Pi<-matres[1,]
            P<-divindex(Pi,cw)
            Pir<-matres[2,]
            Pr<-divindex(Pir,cw)
            isim<-matres[-1,]
            pvalsp<-apply(isim,2,function(x) as.randtest(x[-1],x[1])$pvalue)
            pval<-apply(t(apply(isim,1,divindex,cw)),2,function(x) as.randtest(x[-1],x[1])$pvalue)
        }
        else {
            lres<-apply(do.call("rbind",lapply(ldf,discond,nsp,range)),2,function(x) sum(x*fw))
            Pi<-lres[1:nsp]
            P<-divindex(Pi,cw)
            Pir<-lres[(nsp+1):(2*nsp)]
            Pr<-divindex(Pir,cw)
        }
        res$range<-range
        res$dis<-data.frame(cbind(P,Pr,if(test) pval),row.names=c("Richness","Shannon","Simpson"))
        names(res$dis)<-c("P","Pr",if(test) "Pr(>Pr)")
        res$spdis<-data.frame(cbind(Pi,Pir,if(test) pvalsp),row.names=names(df))
        names(res$spdis)<-c("Pi","Pir",if(test) "Pr(>Pir)")
    }
    else stop("non convenient model")
    res$call<-match.call()
    class(res)<-c("div","spadis")	
    return(res)
}
