summary.div<-function(div.obj,...) {
    UseMethod("summary.div")
}

summary.div.mlm<-function(aov.obj) {
	if(!is.otab(tab<-as.otab(aov.obj$model[[1]])))
		  print("no applicable method for 'summary.div'\n")
	#tab<-aov.obj$model[[1]]
    res<-alist()
    res$call<-aov.obj$call
    res$mod<-attr(aov.obj$term,"order")
    Xterm<-formula(aov.obj$term)[[3]]
    if((length(Xterm)>1)&&(Xterm[[1]]=="/"))
        attr(res$mod,"nested")<-TRUE
    else  attr(res$mod,"nested")<-FALSE
    sm<-summary.aov(aov.obj)
    df<-sm[[1]][[1]]
    nterms<-length(df)-1
    ni<-apply(tab,2,sum)
    n<-sum(tab)
    spw<-ni/n
    ss<-matrix(0,length(sm),length(df))
    for(i in 1:length(sm)) ss[i,]<-sm[[i]][[2]]
    t.names<-c(row.names(sm[[1]])[1:nterms],"Residuals")
    spvar<-data.frame(spw*(1-spw),ss/n,row.names=names(tab))
    div<-data.frame(sapply(spvar,divindex,spw),row.names=c("Richness","Shannon","Simpson"))
    res$df<-df
    attr(res$df,"names")<-t.names
    res$spvar<-spvar
    res$div<-div
    names(res$div)<-names(res$spvar)<-c("Total",t.names)
    res$ni<-as.integer(ni)
    attr(res$ni,"names")<-row.names(spvar)
    Mdiv<-apply(div[,-1],1,function(x) x/df)
    rankerror<-seq(2,nrow(Mdiv),1)
    res$Fdiv<-as.data.frame(t(matrix(Mdiv[rankerror-1,]/Mdiv[rankerror,],nrow=nterms)),row.names=c("Richness","Shannon","Simpson"))
    Msp<-apply(spvar[,-1],1,function(x) x/df)
    res$Fsp<-as.data.frame(t(matrix(Msp[rankerror-1,]/Msp[rankerror,],nrow=nterms)),row.names=row.names(spvar))
    names(res$Fdiv)<-names(res$Fsp)<-t.names[1:nterms]
    class(res)<-"summary.anodiv"
    return(res)
}

summary.div.anodiv<-function(div.obj,nrepet=0) {
    mod<-as.numeric(div.obj$mod)
	h<-attr(div.obj$mod,"hierarchical")
	if(nrepet==0)
		test<-FALSE
	else if(nrepet>0)
		test<-TRUE
	else
		stopifnot(nrepet>=0)
    if(test) {
        if(identical(mod,1)) { ## One-way
            sim<-testintertot(div.obj$Y,div.obj$X,nrepet,"pval")
			pvalsp<-sim$pvalsp
			pvaldiv<-sim$pvaldiv
        }
        else if(identical(mod,c(1,2))) { ## Two-ways nested
            ##main effect
			sim<-testacross(div.obj$Y,div.obj$X,nrepet,"pval")
            pvalsp<-sim$pvalsp
            pvaldiv<-sim$pvaldiv
            ##nested effect
			sim<-testwithin(div.obj$Y,div.obj$X,nrepet,"pval")
            pvalsp<-cbind(pvalsp,sim$pvalsp)
			pvaldiv<-cbind(pvaldiv,sim$pvaldiv)
		}
		else if(h) { ## Hierarchical
			nfac<-length(mod)
			## randomization of second-level units across first ranked factor levels
			Xred<-div.obj$X[,1:2]
			sim<-testacross(div.obj$Y,Xred,nrepet,opt="pval")
			pvalsp<-sim$pvalsp
            pvaldiv<-sim$pvaldiv
			## conditional randomization of units of order n+1 across units of order n within units of order n-1
			for(i in 2:(nfac-1)) {
				Xred<-div.obj$X[,(i-1):(i+1)]
				sim<-testacrosswithin(div.obj$Y,Xred,nrepet,opt="pval")
				pvalsp<-cbind(pvalsp,sim$pvalsp)
				pvaldiv<-cbind(pvaldiv,sim$pvaldiv)
			}
			## conditional randomization of individuals across units of highest order
			Xred<-div.obj$X[,(nfac-1):nfac]
			sim<-testwithin(div.obj$Y,Xred,nrepet,opt="pval")
			pvalsp<-cbind(pvalsp,sim$pvalsp)
			pvaldiv<-cbind(pvaldiv,sim$pvaldiv)
		}
		else
			stop("test not yet implemented for this model\n")
    }
    nterms<-length(div.obj$df)-1
    div<-data.frame(sapply(div.obj$spvar,divindex,div.obj$spw),row.names=c("Richness","Shannon","Simpson"))
    Mdiv<-apply(div[,-1],1,function(x) x/div.obj$df)
    rankerror<-seq(2,nrow(Mdiv),1)
    Fdiv<-matrix(Mdiv[rankerror-1,]/Mdiv[rankerror,],nrow=nterms)
    Msp<-apply(div.obj$spvar[,-1],1,function(x) x/div.obj$df)
    Fsp<-matrix(Msp[rankerror-1,]/Msp[rankerror,],nrow=nterms)

    res<-alist()
    res$call<-div.obj$call
    res$mod<-div.obj$mod
    res$df<-div.obj$df
    res$div<-div
    names(res$div)<-names(div.obj$spvar)
    res$Fdiv<-as.data.frame(t(Fdiv),row.names=c("Richness","Shannon","Simpson"))
    res$ni<-as.vector(table(div.obj$Y))
    names(res$ni)<-row.names(div.obj$spvar)
    res$spvar<-div.obj$spvar
    res$Fsp<-as.data.frame(t(Fsp),row.names=row.names(div.obj$spvar))

    names(res$Fdiv)<-names(res$Fsp)<-names(div.obj$df)[1:nterms]
    if(test) {
        res$nrepet<-nrepet
        res$pvaldiv<-data.frame(pvaldiv,row.names=c("Richness","Shannon","Simpson"))
        res$pvalsp<-data.frame(pvalsp,row.names=levels(div.obj$Y))
        names(res$pvaldiv)<-names(res$pvalsp)<-names(div.obj$X)
    }
    class(res)<-"summary.anodiv"
    return(res)
}  
    
print.summary.anodiv<-function(smry) {
    cat("class: ",class(smry),"\n")
    cat("call: ")
    print(smry$call)
    cat("mod: ",smry$mod)
    if(!is.null(smry$nrepet)) {
        test<-TRUE
        cat("\nMonte Carlo tests based on",smry$nrepet,"replicates")
    }
    else test<-FALSE
    cat("\n")
    f<-function(a) return(a<-ifelse(is.na(a),"",signif(a,digit=3)))
   for (i in row.names(smry$div)) {
        cat("\n$", i, ":\n", sep="")
		print.default(cbind(Df=c(Total=NA,smry$df),apply(t(rbind(Diversity=smry$div[i,],"F-value"=c(Total=NA,smry$Fdiv[i,],Residuals=NA),
       "Pr(>F)"=if(test) c(Total=NA,smry$pvaldiv[i,],Residuals=NA))),c(1,2),f)),na.print="",quote=FALSE)
    }
    cat<-("\n")
    cat("\nDo you want to print by-species results ? (y/n) :\n")
    opt<-as.character(readLines(n=1))
    if((opt=="y")||(opt=="Y"))
        for (i in row.names(smry$spvar)) {   
            cat("\nResponse $",i," (n=",smry$ni[i],"):\n", sep="")
			 print.default(cbind(Df=c(Total=NA,smry$df),apply(t(rbind(Variance=smry$spvar[i,],"F-value"=c(Total=NA,smry$Fsp[i,],Residuals=NA),
            "Pr(>F)"=if(test) c(Total=NA,smry$pvalsp[i,],Residuals=NA))),c(1,2),f)),na.print="",quote=FALSE)
		}
}

summary.div.dudi<-function(div.obj) {
    res<-alist()
    res$divopt<-div.obj$divopt
    res$call<-div.obj$call
    res$Dtot<-div.obj$Dtot
    res$Dfit<-sum(div.obj$eig)
    #res$Dres<-res$Dtot-res$Dfit
    #res$Drat<-res$Dfit/res$Dtot
    if(!is.null(div.obj$pvalue)) {
        res$pvalue<-div.obj$pvalue
        res$nrepet<-div.obj$nrepet
    }
    class(res)<-"summary.dudiv"
    return(res)
}

print.summary.dudiv<-function(smry) {
    cat("class: ",class(smry),"\n")
    if(smry$divopt==1) cat("metric: Richness\n")
    if(smry$divopt==2) cat("metric: Shannon\n")
    if(smry$divopt==3) cat("metric: Simpson\n")
    cat("call: ")
    print(smry$call)
    cat("\n")
    f<-function(a) return(signif(a,digit=3))
    cat("total diversity:",f(smry$Dtot),"\n")
    cat("explained diversity:",f(smry$Dfit),"\n")
    cat("ratio of explained diversity:",f(smry$Dfit/smry$Dtot),"\n")
    if(!is.null(smry$pvalue)) {
        cat("Pr(>ratio):",smry$pvalue)
        cat(" based on",smry$nrepet,"replicates\n")
    }
    cat("\n")
}

summary.div.dissim<-function(div.obj) {
	res<-alist()
	res$div<-div.obj$Div
	if(!is.null(div.obj$call$formula))
		res$div<-rbind(res$div,DYmod=c(sum(div.obj$dissim[,1]*div.obj$weight),sum(div.obj$dissim[,2]*div.obj$weight),sum(div.obj$dissim[,3]*div.obj$weight)))
	res$call<-div.obj$call
	class(res)<-"summary.dissim"
    return(res)
}

print.summary.dissim<-function(smry) {
    cat("class: ",class(smry),"\n")
    cat("call: ")
    print(smry$call)
    cat("\n")
    f<-function(a) return(ifelse(a<=.Machine$double.eps,0,signif(a,digit=3)))
    print(apply(smry$div,c(1:2),f))
    cat("\n")
}

summary.div.variodis<-function(div.obj) {
	res<-alist()
	res$div<-div.obj$Div
	if(!is.null(div.obj$call$formula))
		res$div<-rbind(res$div,DYmod=c(sum(div.obj$richness[,1]*2*div.obj$w),sum(div.obj$Shannon[,1]*2*div.obj$w),sum(div.obj$Simpson[,1]*2*div.obj$w)))
	res$call<-div.obj$call
	class(res)<-"summary.variodis"
    return(res)
}

print.summary.variodis<-function(smry) {
    cat("class: ",class(smry),"\n")
    cat("call: ")
    print(smry$call)
    cat("\n")
    f<-function(a) return(ifelse(a<=.Machine$double.eps,0,signif(a,digit=3)))
    print(apply(smry$div,c(1:2),f))
    cat("\n")
}
