Cformula<-function(formula,data) {
    Terms<-terms(formula,"Condition",data=data)
    formula<-formula(Terms,width.cutoff=500)
    Yterm<-formula[[2]]
    Y<-eval(Yterm,data,parent.frame())
    indPartial<-attr(Terms,"specials")$Condition
    Z<-NULL
    if(!is.null(indPartial)) {
        partterm<-attr(Terms,"variables")[[1+indPartial]]
        Zterm<-deparse(partterm[[2]])
        Z.formula<-as.formula(paste("~",Zterm))
        Z<-model.frame(Z.formula,data,na.action=na.fail)
        if((ncol(Z)==1)&&(is.factor(Z[,1]))) Z<-Z[,1]
        if(length(as.list(formula[[3]]))==2) X<-NULL
        else {
            Xterm<-deparse(formula[[indPartial]][[2]])
            X.formula<-as.formula(paste("~",Xterm))
            X<-model.frame(X.formula,data,na.action=na.fail)
            if((ncol(X)==1)&&(is.factor(X[,1]))) X<-X[,1]
        }
    }
    else {
        Xterm<-deparse(formula[[3]])
        X.formula<-as.formula(paste("~",Xterm))
        X<-model.frame(X.formula,data,na.action=na.fail)
        if((ncol(X)==1)&&(is.factor(X[,1]))) X<-X[,1]
    }
    list(Y=Y,X=X,Z=Z)
}

divindex<-function(x,col.w)
  return(c(sum(x*1/col.w,na.rm=TRUE),sum(x*log(1/col.w)/(1-col.w),na.rm=TRUE),sum(x)))
  
#is.hierarchical<-function(df,direction=c("upward","downward")) {
#	dir<-direction[1]
#	stopifnot(dir%in%c("upward","downward"))
#	if(dir=="upward")
#		ind<-1
#	else if(dir=="downward")
#		ind<-2 
#	nc<-ncol(df)
#	for (i in 1:(nc - 1)) {
#       t <- table(df[, c(i, i + 1)])
#		w <- apply(t, ind, function(x) sum(x != 0))
#       if (any(w != 1))
#		return(FALSE)
#		}
#	return(TRUE)
#}

## Fast function for computing sum of squares of the fitted table from routines 'dqrls{base}'. 
lmwfit<-function(y,x,sqlw,sqcw) {
    n<-nrow(x)
    p<-ncol(x)
    ny<-NCOL(y)
    storage.mode(y)<-"double"
#z<-.Fortran("dqrls",qr=x*sqlw,n=n,p=p,y=y*sqlw,ny=ny,tol=1e-07,coefficients=mat.or.vec(p,ny),residuals=y,effects=mat.or.vec(n,ny),rank =integer(1),pivot=1:p,qraux=double(p),work=double(2*p),PACKAGE="base")
	z<-.Fortran("dqrls",qr=x*sqlw,n=n,p=p,y=y*sqlw,ny=ny,tol=1e-07,coefficients=mat.or.vec(p,ny),residuals=y,effects=mat.or.vec(n,ny),rank =integer(1),pivot=1:p,qraux=double(p),work=double(2*p),PACKAGE='diversity.R')
	tab<-sqlw*y-z$residuals
    tab<-sweep(tab,2,sqcw,"*")
    eig<-sum(tab^2)
}

lseq <- function(from,to,length.out) {
  exp(seq(log(from),log(to),length.out=length.out))
}

#varinter<-function(Ctab) {
#    N<-sum(Ctab)
#    rw<-rowSums(Ctab)/N
#    cw<-colSums(Ctab)/N
#    Ctab<-t(apply(Ctab,1,function(x) if(sum(x)==0) cw else x/sum(x)))
#    Ctab<-sweep(Ctab,2,cw)
#    Xfac<-as.factor(row.names(Ctab))
#    return(apply(Ctab,2,testinter,npermut=1,pl=rw,pc=1,moda=length(Xfac),indica=Xfac,l1=length(Xfac),c1=1))
#}

Vinter <- function(tab) {
    res<-.C("Vinter",
			as.double(t(tab)),
			as.integer(nrow(tab)),
			as.integer(ncol(tab)),
			as.integer(sum(tab)),
			SVaci=double(ncol(tab)),
			PACKAGE='diversity.R')$SVaci
	return(res)
}

centrage<-function(tabY) {
	stopifnot(ncol(tabY)!=1)
	N<-sum(tabY)
	rw<-rowSums(tabY)/N
	cw<-colSums(tabY)/N
	tab<-t(apply(tabY,1,function(x) if(sum(x)==0) cw else x/sum(x)))
	tab<-sweep(tab,2,cw)
	attr(tab,"rw")<-rw
	attr(tab,"cw")<-cw
	class(tab)<-c(class(tab),"centered")
	return(tab)
}

###From ade4########
testinter <- function(npermut, pl, pc, moda, indica, tab, l1, c1)
.C("testinter",
as.integer(npermut),
as.double(pl),
as.integer(length(pl)),
as.double(pc),
as.integer(length(pc)),
as.integer(moda),
as.double(indica),
as.integer(length(indica)),
as.double(t(tab)),
as.integer(l1),
as.integer(c1),
inersim = double(npermut+1),
PACKAGE='diversity.R')$inersim

"scatterutil.sub" <- function (cha, csub, possub = "bottomleft") {
    cha <- as.character(cha)
    if (length(cha) == 0) 
	return(invisible())
    if (is.null(cha)) 
	return(invisible())
    if (is.na(cha)) 
	return(invisible())
    if (any(cha == ""))
	return(invisible())
    if (csub == 0) 
	return(invisible())
    cex0 <- par("cex") * csub
    cha <- paste(" ", cha, " ", sep = "")
    xh <- strwidth(cha, cex = cex0)
    yh <- strheight(cha, cex = cex0) * 5/3
    if (possub == "bottomleft") {
        x1 <- par("usr")[1]
        y1 <- par("usr")[3]
        rect(x1, y1, x1 + xh, y1 + yh, col = "white", border = 0)
        text(x1 + xh/2, y1 + yh/2, cha, cex = cex0)
    }
    else if (possub == "topleft") {
        x1 <- par("usr")[1]
        y1 <- par("usr")[4]
        rect(x1, y1, x1 + xh, y1 - yh, col = "white", border = 0)
        text(x1 + xh/2, y1 - yh/2, cha, cex = cex0)
    }
    else if (possub == "bottomright") {
        x1 <- par("usr")[2]
        y1 <- par("usr")[3]
        rect(x1, y1, x1 - xh, y1 + yh, col = "white", border = 0)
        text(x1 - xh/2, y1 + yh/2, cha, cex = cex0)
    }
    else if (possub == "topright") {
        x1 <- par("usr")[2]
        y1 <- par("usr")[4]
        rect(x1, y1, x1 - xh, y1 - yh, col = "white", border = 0)
        text(x1 - xh/2, y1 - yh/2, cha, cex = cex0)
    }
}

"scatterutil.eigen" <- function (w, nf = NULL, xmax = length(w), ymin=min(0,min(w)), ymax = max(w), wsel = 1, sub = "Eigenvalues",
csub = 2, possub = "topright",box=FALSE,yaxt="n") 
{
    opar <- par(mar = par("mar"),plt=par("plt"))
    on.exit(par(opar))
    par(mar = c(0.8, 2.8, 0.8, 0.8),plt=par("plt"))
    if (length(w) < xmax) 
	w <- c(w, rep(0, xmax - length(w)))
# modif by TJ to handle 3 colors (respented/kept/others)
    col.w <- rep("white", length(w))
    if(!is.null(nf)) {col.w[1:nf] <- "grey"}
    col.w[wsel] <- "black"
#
    barplot(w, col = col.w, ylim = c(ymin, ymax)*1.1,yaxt=yaxt)
    scatterutil.sub(cha = sub, csub = max(.8,csub), possub = possub)
    if(box) box()
}
