\encoding{latin1}
\name{bornes2knb}
\alias{bornes2knb}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{From distance classes to neighbouring graphs}
\description{
'bornes2knb' computes \eqn{k} neighbouring graphs, one for each distance class defined in \eqn{d}
}
\usage{
bornes2knb(xy, d)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{xy}{a data frame with two columns giving the \eqn{x} and \eqn{y} co-ordinates of each point.}
  \item{d}{a vector defining the distance classes.}
}
\details{
Two points \eqn{a} and \eqn{b} separated by a distance of \eqn{d(a,b)}, are considered to be neigbhours at scale \eqn{d=[d(k)+d(k+1)]/2} if and only if \eqn{d(k)<=d(a,b)<d(k+1)}.}
\value{
An object of class 'knb', i.e. a list of \eqn{k} objects of class'nb', giving the list of points that are neigbhours at scale \eqn{d}. 'nb' is the main class used to defined neighbouring graphs in package 'spded'. 
}
\references{Couteron, P. & Ollier, S. 2005. A generalized, variogram-based framework for mulstiscale ordination. Ecology, 86(4): 828-834.}
\author{sebastien.ollier@u-psud.fr}
\seealso{\link{kmsov.rtest}, \link{spadis}}
\examples{
xy<-data.frame(x=rep(c(1,2),4),y=c(rep(4,2),rep(3,2),rep(2,2),rep(1,2)))
d<-c(0,1.1,2.1,3.1,4.1)
knb<-bornes2knb(xy,d)
summary(knb)
par(mfrow=c(2,2))
for(i in 1:4)
	plot(knb[[i]],xy)
}
