\encoding{latin1}
\name{otab}
\alias{otab}
\alias{as.otab}
\alias{is.otab}
\alias{summary.otab}
\alias{as.data.frame.otab}
\title{Species occurrence table creation}
\description{
'otab' creates a species occurrence table, i.e. a complete binary matrix with as many rows as individuals (or occurrences) and as many columns as species.
}
\usage{
otab(fac)
as.otab(x)
is.otab(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
\item{fac}{a factor of the species' name of each occurrence.}
\item{x}{a two-dimensional R object (table, data.frame or matrix) with individuals (or occurrences) as rows and species as columns.}
}
\value{
'otab' returns an object of class 'otab table' with as many rows as 'length(fac)' and as many columns as 'nlevels(fac)', so that nrow(otab(fac))=sum(otab(fac)).
  
'as.otab' returns an object of class 'otab table' with as many rows as 'x' and as many columns as 'x'.
  
'is.otab' returns TRUE if 'x' is of class 'otab'.
  
There is a 'summary' method for objects of class 'otab', which performs individual species variances and basic diversity indices.  

}
\references{Couteron, P. & Plissier, R. 2004. Additive apportionment of species diversity: twowards more sophisticated models and analyses. Oikos, 107(1): 215-221.

Plissier, R., Couteron, P., Dray, S. & Sabatier, D. 2003. Consitency between ordination techniques and diversity measurements: two strategies for species occurrence data. Ecology, 84 (1): 242-251.}
\author{Raphael.Pelissier@ird.fr}
\seealso{\code{\link{odf}}}
\examples{
data(PSE)
PSE.otab<-otab(PSE$Tfac)
str(PSE.otab)
is.otab(PSE.otab) #TRUE
summary(PSE.otab)
}


