\encoding{latin1}
\name{plot.div}
\alias{plot.div}
\title{Plot factorial maps.}
\description{
'plot.div' is a method for plotting factorial maps for objects of class 'div dudi'.
}
\usage{
plot.div(dudiv, xax = 1, yax = 2, labrow = "row.names", labsp = "sp.names", title = TRUE, eigen = "ratio", ...)
}
\arguments{
  \item{dudiv}{an object of class 'div dudi'.}
  \item{xax}{an integer indicating the rank (column number) of the factorial axis to be used as x-axis.}
  \item{yax}{an integer indicating the rank (column number) of the factorial axis to be used as y-axis.}
  \item{labrow}{a character string indicating row labels to be used. "row.names" to call function 'row.names()', "row.codes" to convert the row names into numerical values indicating the row numbers. Any other character string simply display points (whithout any name).}
  \item{labsp}{a character string indicating species labels to be used. "sp.names" to call function 'row.names()', "sp.codes" to convert the row names into numerical values indicating the row numbers. Any other character string simply display points (whithout any name).}
  \item{title}{a logical value indicating whether the type of analysis should be displayed as title of the graphic.}
  \item{eigen}{a character string indicating wether eigenvalues bar plot should indicates absolute ("abs") or relative ("ratio") eigenvalues. "ratio" is the default value plotting each eigenvalue related to the sum of all eigenvalues. "abs" is the only alternative.}
  \item{\dots}{further arguments passed to or from other methods.}
}
\author{Raphael.Pelissier@ird.fr}
\seealso{\link{dudi.div}, \link{ca.richness}, \link{cwca.shannon}, \link{nsca.simpson}}
\examples{
data(CFI)
div1<-dudi.div(CFI$tab,scanopt=FALSE,scannf=FALSE)
plot(div1)

div2<-ca.richness(tab~topo,CFI,test=FALSE) #Select the number of axes:
2
plot(div2)
}