\encoding{latin1}
\name{rtest.pcaiv}
\alias{rtest.pcaiv}
\title{Monte-Carlo test on the projected inertia percentage.}
\description{performs a Monte-Carlo test on the projected inertia percentage.}
\usage{
rtest.pcaiv(xtest, nrepet = 99, ...)
}
\arguments{
  \item{xtest}{an object of class 'pcaiv'}
  \item{nrepet}{the number of permutations}
  \item{\dots}{further arguments passed to or from other methods}
}
\details{the test is implemented by permuting at random the rows of the dependent raw data matrix 'Y' and recomputing inertia of the projected table via a call to the Fortran routine dqrls{base} in function 'eig.wfit'. 
 }
\value{a list of the class 'rtest'}
\author{Raphael.Pelissier@ird.fr}
\references{Legendre, P. & Legendre, L. 1998. Numerical ecology. Elsevier, Amsterdam. 853 pp.}
\seealso{\link{rtest}}
\examples{
data(CFI)
ca<-dudi.div(CFI$tab,scanopt=FALSE,opt=1,scannf=FALSE,nf=3)
ca.dbh<-pcaiv(ca,CFI$dbh,scannf=FALSE)
sum(ca.dbh$eig)/sum(ca$eig)
test<-rtest(ca.dbh)
test
plot(test)
}
